// $ANTLR : "CVCL.g" -> "CVCLParser.java"$

  package fmrisc.Proving.CVCL;
  import fmrisc.Syntax.*;
  import fmrisc.ProofNavigator.*;
  import fmrisc.ProofNavigator.Commands.*;
  import java.util.*;

import antlr.TokenBuffer;
import antlr.TokenStreamException;
import antlr.TokenStreamIOException;
import antlr.ANTLRException;
import antlr.LLkParser;
import antlr.Token;
import antlr.TokenStream;
import antlr.RecognitionException;
import antlr.NoViableAltException;
import antlr.MismatchedTokenException;
import antlr.SemanticException;
import antlr.ParserSharedInputState;
import antlr.collections.impl.BitSet;

public class CVCLParser extends antlr.LLkParser       implements CVCLParserTokenTypes
 {

  private CVCLLexer lexer;
  private CVCL cvcl;
  public CVCLParser(CVCL cvcl, CVCLLexer lexer)
  {
  	this(lexer);
  	this.lexer = lexer;
  	this.cvcl = cvcl;
  }

protected CVCLParser(TokenBuffer tokenBuf, int k) {
  super(tokenBuf,k);
  tokenNames = _tokenNames;
}

public CVCLParser(TokenBuffer tokenBuf) {
  this(tokenBuf,1);
}

protected CVCLParser(TokenStream lexer, int k) {
  super(lexer,k);
  tokenNames = _tokenNames;
}

public CVCLParser(TokenStream lexer) {
  this(lexer,1);
}

public CVCLParser(ParserSharedInputState state) {
  super(state,1);
  tokenNames = _tokenNames;
}

	public final AST  main() throws RecognitionException, TokenStreamException {
		 AST value = null; boolean last=false; ;
		
		
		try {      // for error handling
			value=valueExp();
		}
		catch (RecognitionException e) {
			if (inputState.guessing==0) {
				
				cvcl.setError(e.toString()); 
				consumeUntil(SEMICOLON); consume();
				return null;
				
			} else {
				throw e;
			}
		}
		catch (TokenStreamException e) {
			if (inputState.guessing==0) {
				
				cvcl.setError(e.toString()); 
				try
				{ lexer.consumeUntil(';'); 
					lexer.consume(); }
				catch(antlr.CharStreamException f)
				{ }
				return null;
				
			} else {
				throw e;
			}
		}
		return value;
	}
	
	public final Expression  valueExp() throws RecognitionException, TokenStreamException {
		 Expression value = null; ;
		
		TypedIdentifier[] p = null; Expression v = null;
		
		switch ( LA(1)) {
		case LITERAL_LAMBDA:
		{
			match(LITERAL_LAMBDA);
			p=paramList();
			match(5);
			v=valueExp();
			if ( inputState.guessing==0 ) {
				value = Construct.lambdaTerm(p, v);
			}
			break;
		}
		case LITERAL_ARRAY:
		{
			match(LITERAL_ARRAY);
			p=paramList();
			match(5);
			v=valueExp();
			if ( inputState.guessing==0 ) {
				value = Construct.arrayTerm(p, v);
			}
			break;
		}
		case LITERAL_FORALL:
		{
			match(LITERAL_FORALL);
			p=paramList();
			match(5);
			v=valueExp();
			if ( inputState.guessing==0 ) {
				value = Construct.forallFormula(p, v);
			}
			break;
		}
		case LITERAL_EXISTS:
		{
			match(LITERAL_EXISTS);
			p=paramList();
			match(5);
			v=valueExp();
			if ( inputState.guessing==0 ) {
				value = Construct.existsFormula(p, v);
			}
			break;
		}
		case IDENT:
		case 9:
		case LITERAL_LET:
		case LITERAL_NOT:
		case 39:
		case 40:
		case NUMBER:
		case LITERAL_TRUE:
		case LITERAL_FALSE:
		case 50:
		case LITERAL_IF:
		{
			value=valueExp90();
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		return value;
	}
	
	public final AST  declaration() throws RecognitionException, TokenStreamException {
		 AST decl = null ; ;
		
		Token  i = null;
		Type t=null; Expression v=null;
		
		i = LT(1);
		match(IDENT);
		match(5);
		{
		switch ( LA(1)) {
		case LITERAL_TYPE:
		{
			match(LITERAL_TYPE);
			{
			switch ( LA(1)) {
			case 7:
			{
				match(7);
				t=typeExp();
				break;
			}
			case EOF:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			if ( inputState.guessing==0 ) {
				decl = Construct.typeDeclaration(
				Construct.typeDeclIdentifier(i.getText()), t);
			}
			break;
		}
		case IDENT:
		case 9:
		case LITERAL_BOOLEAN:
		case LITERAL_INT:
		case LITERAL_REAL:
		case 15:
		case 17:
		case LITERAL_ARRAY:
		case LITERAL_SUBTYPE:
		case LITERAL_LET:
		{
			t=typeExp();
			{
			switch ( LA(1)) {
			case 7:
			{
				match(7);
				v=valueExp();
				break;
			}
			case EOF:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			if ( inputState.guessing==0 ) {
				decl = Construct.valueDeclaration(
				Construct.valueDeclIdentifier(i.getText()), t, v);
			}
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		return decl;
	}
	
	public final Type  typeExp() throws RecognitionException, TokenStreamException {
		 Type type=null; ;
		
		Type t0 = null; Type t1 = null; Vector v = null;
		
		boolean synPredMatched11 = false;
		if (((_tokenSet_0.member(LA(1))))) {
			int _m11 = mark();
			synPredMatched11 = true;
			inputState.guessing++;
			try {
				{
				typeExpBase();
				match(8);
				}
			}
			catch (RecognitionException pe) {
				synPredMatched11 = false;
			}
			rewind(_m11);
inputState.guessing--;
		}
		if ( synPredMatched11 ) {
			t0=typeExpBase();
			match(8);
			t1=typeExp();
			if ( inputState.guessing==0 ) {
				type = Construct.functionType(new Type[] { t0 }, t1);
			}
		}
		else {
			boolean synPredMatched13 = false;
			if (((LA(1)==9))) {
				int _m13 = mark();
				synPredMatched13 = true;
				inputState.guessing++;
				try {
					{
					match(9);
					typeExp();
					match(10);
					}
				}
				catch (RecognitionException pe) {
					synPredMatched13 = false;
				}
				rewind(_m13);
inputState.guessing--;
			}
			if ( synPredMatched13 ) {
				match(9);
				t0=typeExp();
				if ( inputState.guessing==0 ) {
					v = new Vector(); v.add(t0);
				}
				{
				int _cnt15=0;
				_loop15:
				do {
					if ((LA(1)==10)) {
						match(10);
						t0=typeExp();
						if ( inputState.guessing==0 ) {
							v.add(t0);
						}
					}
					else {
						if ( _cnt15>=1 ) { break _loop15; } else {throw new NoViableAltException(LT(1), getFilename());}
					}
					
					_cnt15++;
				} while (true);
				}
				match(11);
				match(8);
				t1=typeExp();
				if ( inputState.guessing==0 ) {
					type = Construct.functionType(ASTUtil.toTypeArray(v), t1);
				}
			}
			else if ((_tokenSet_0.member(LA(1)))) {
				t0=typeExpBase();
				if ( inputState.guessing==0 ) {
					type = t0;
				}
			}
			else {
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			return type;
		}
		
	public final TypeDeclaration  tdeclaration() throws RecognitionException, TokenStreamException {
		 TypeDeclaration decl = null; ;
		
		Token  i = null;
		Type t=null;
		
		i = LT(1);
		match(IDENT);
		match(5);
		match(LITERAL_TYPE);
		match(7);
		t=typeExp();
		if ( inputState.guessing==0 ) {
			decl = Construct.typeDeclaration(
			Construct.typeDeclIdentifier(i.getText()), t);
		}
		return decl;
	}
	
	public final TypeDeclaration  tdeclaration0() throws RecognitionException, TokenStreamException {
		 TypeDeclaration decl = null; ;
		
		Token  i = null;
		Type t=null;
		
		i = LT(1);
		match(IDENT);
		{
		switch ( LA(1)) {
		case 5:
		{
			match(5);
			match(LITERAL_TYPE);
			break;
		}
		case 7:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		match(7);
		t=typeExp();
		if ( inputState.guessing==0 ) {
			decl = Construct.typeDeclaration(
			Construct.typeDeclIdentifier(i.getText()), t);
		}
		return decl;
	}
	
	public final Type  typeExpBase() throws RecognitionException, TokenStreamException {
		 Type type = null; ;
		
		Token  i = null;
		Token  i1 = null;
		Token  i2 = null;
		Type t0 = null; Type t1 = null; 
		TypeDeclaration d1 = null; TypeDeclaration d2 = null;
		Expression v0 = null; Expression v1 = null; Vector v = null;
		
		switch ( LA(1)) {
		case IDENT:
		{
			i = LT(1);
			match(IDENT);
			if ( inputState.guessing==0 ) {
				type = Construct.reference(i.getText());
			}
			break;
		}
		case LITERAL_BOOLEAN:
		{
			match(LITERAL_BOOLEAN);
			if ( inputState.guessing==0 ) {
				type = Construct.atomicType("BOOLEAN");
			}
			break;
		}
		case LITERAL_INT:
		{
			match(LITERAL_INT);
			if ( inputState.guessing==0 ) {
				type = Construct.atomicType("INT");
			}
			break;
		}
		case LITERAL_REAL:
		{
			match(LITERAL_REAL);
			if ( inputState.guessing==0 ) {
				type = Construct.atomicType("REAL");
			}
			break;
		}
		case 17:
		{
			match(17);
			if ( inputState.guessing==0 ) {
				v = new Vector();
			}
			i1 = LT(1);
			match(IDENT);
			match(5);
			t0=typeExp();
			if ( inputState.guessing==0 ) {
				v.add(Construct.typedIdentifier(
						   Construct.valueDeclIdentifier(i1.getText()), t0));
			}
			{
			_loop24:
			do {
				if ((LA(1)==10)) {
					match(10);
					i2 = LT(1);
					match(IDENT);
					match(5);
					t0=typeExp();
					if ( inputState.guessing==0 ) {
						v.add(Construct.typedIdentifier(
							       Construct.valueDeclIdentifier(i2.getText()), t0));
					}
				}
				else {
					break _loop24;
				}
				
			} while (true);
			}
			match(18);
			if ( inputState.guessing==0 ) {
				type = Construct.recordType(ASTUtil.toTypedIdentifierArray(v));
			}
			break;
		}
		case LITERAL_ARRAY:
		{
			match(LITERAL_ARRAY);
			t0=typeExp();
			match(LITERAL_OF);
			t1=typeExp();
			if ( inputState.guessing==0 ) {
				type = Construct.arrayType(t0, t1);
			}
			break;
		}
		case LITERAL_SUBTYPE:
		{
			match(LITERAL_SUBTYPE);
			match(9);
			v0=valueExp();
			match(11);
			if ( inputState.guessing==0 ) {
				type = Construct.subType(v0);
			}
			break;
		}
		case LITERAL_LET:
		{
			match(LITERAL_LET);
			d1=tdeclaration0();
			if ( inputState.guessing==0 ) {
				v = new Vector(); v.add(d1);
			}
			{
			_loop26:
			do {
				if ((LA(1)==10)) {
					match(10);
					d2=tdeclaration0();
					if ( inputState.guessing==0 ) {
						v.add(d2);
					}
				}
				else {
					break _loop26;
				}
				
			} while (true);
			}
			match(LITERAL_IN);
			t0=typeExp();
			if ( inputState.guessing==0 ) {
				type = Construct.letType(ASTUtil.toTypeDeclarationArray(v), t0);
			}
			break;
		}
		case 9:
		{
			match(9);
			t0=typeExp();
			match(11);
			if ( inputState.guessing==0 ) {
				type = t0;
			}
			break;
		}
		default:
			boolean synPredMatched18 = false;
			if (((LA(1)==15))) {
				int _m18 = mark();
				synPredMatched18 = true;
				inputState.guessing++;
				try {
					{
					match(15);
					typeExp();
					match(10);
					}
				}
				catch (RecognitionException pe) {
					synPredMatched18 = false;
				}
				rewind(_m18);
inputState.guessing--;
			}
			if ( synPredMatched18 ) {
				match(15);
				if ( inputState.guessing==0 ) {
					v = new Vector();
				}
				t0=typeExp();
				if ( inputState.guessing==0 ) {
					v.add(t0);
				}
				{
				int _cnt20=0;
				_loop20:
				do {
					if ((LA(1)==10)) {
						match(10);
						t1=typeExp();
						if ( inputState.guessing==0 ) {
							v.add(t1);
						}
					}
					else {
						if ( _cnt20>=1 ) { break _loop20; } else {throw new NoViableAltException(LT(1), getFilename());}
					}
					
					_cnt20++;
				} while (true);
				}
				match(16);
				if ( inputState.guessing==0 ) {
					type = Construct.tupleType(ASTUtil.toTypeArray(v));
				}
			}
			else {
				boolean synPredMatched22 = false;
				if (((LA(1)==15))) {
					int _m22 = mark();
					synPredMatched22 = true;
					inputState.guessing++;
					try {
						{
						match(15);
						typeExp();
						match(16);
						}
					}
					catch (RecognitionException pe) {
						synPredMatched22 = false;
					}
					rewind(_m22);
inputState.guessing--;
				}
				if ( synPredMatched22 ) {
					match(15);
					t0=typeExp();
					match(16);
					if ( inputState.guessing==0 ) {
						type = t0;
					}
				}
				else if ((LA(1)==15)) {
					match(15);
					v0=valueExp();
					match(22);
					v1=valueExp();
					match(16);
					if ( inputState.guessing==0 ) {
						type = Construct.subrangeType(v0, v1);
					}
				}
			else {
				throw new NoViableAltException(LT(1), getFilename());
			}
			}}
			return type;
		}
		
	public final TypedIdentifier[]  paramList() throws RecognitionException, TokenStreamException {
		 TypedIdentifier[] params = null; ;
		
		Vector sequence = new Vector();
		
		match(9);
		param(sequence);
		{
		_loop83:
		do {
			if ((LA(1)==10)) {
				match(10);
				param(sequence);
			}
			else {
				break _loop83;
			}
			
		} while (true);
		}
		match(11);
		if ( inputState.guessing==0 ) {
			params = ASTUtil.toTypedIdentifierArray(sequence);
		}
		return params;
	}
	
	public final Expression  valueExp90() throws RecognitionException, TokenStreamException {
		 Expression value = null; ;
		
		ValueDeclaration v1 = null; ValueDeclaration v2 = null; Expression v3=null; 
			Vector v = null;
		
		switch ( LA(1)) {
		case LITERAL_LET:
		{
			match(LITERAL_LET);
			v1=vdeclaration();
			if ( inputState.guessing==0 ) {
				v = new Vector(); v.add(v1);
			}
			{
			_loop32:
			do {
				if ((LA(1)==10)) {
					match(10);
					v2=vdeclaration();
					if ( inputState.guessing==0 ) {
						v.add(v2);
					}
				}
				else {
					break _loop32;
				}
				
			} while (true);
			}
			match(LITERAL_IN);
			v3=valueExp90();
			if ( inputState.guessing==0 ) {
				value = 
					Construct.letExpression(ASTUtil.toValueDeclarationArray(v), v3);
			}
			break;
		}
		case IDENT:
		case 9:
		case LITERAL_NOT:
		case 39:
		case 40:
		case NUMBER:
		case LITERAL_TRUE:
		case LITERAL_FALSE:
		case 50:
		case LITERAL_IF:
		{
			value=valueExp70();
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		return value;
	}
	
	public final ValueDeclaration  vdeclaration() throws RecognitionException, TokenStreamException {
		 ValueDeclaration decl = null ; ;
		
		Token  i = null;
		Type t=null; Expression v=null;
		
		i = LT(1);
		match(IDENT);
		{
		switch ( LA(1)) {
		case 5:
		{
			match(5);
			t=typeExp();
			break;
		}
		case 7:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		match(7);
		v=valueExp();
		if ( inputState.guessing==0 ) {
			decl = Construct.valueDeclaration(
				          Construct.valueDeclIdentifier(i.getText()), t, v);
		}
		return decl;
	}
	
	public final Expression  valueExp70() throws RecognitionException, TokenStreamException {
		 Expression value = null; ;
		
		Expression v0 = null;
		
		boolean synPredMatched35 = false;
		if (((_tokenSet_1.member(LA(1))))) {
			int _m35 = mark();
			synPredMatched35 = true;
			inputState.guessing++;
			try {
				{
				valueExp60();
				match(28);
				}
			}
			catch (RecognitionException pe) {
				synPredMatched35 = false;
			}
			rewind(_m35);
inputState.guessing--;
		}
		if ( synPredMatched35 ) {
			value=valueExp60();
			match(28);
			v0=valueExp70();
			if ( inputState.guessing==0 ) {
				value = Construct.impliesFormula(value, v0);
			}
		}
		else if ((_tokenSet_1.member(LA(1)))) {
			value=valueExp60();
			{
			_loop37:
			do {
				if ((LA(1)==29)) {
					match(29);
					v0=valueExp70();
					if ( inputState.guessing==0 ) {
						value = Construct.equivalentFormula(value, v0);
					}
				}
				else if ((LA(1)==LITERAL_XOR)) {
					match(LITERAL_XOR);
					v0=valueExp70();
					if ( inputState.guessing==0 ) {
						value = Construct.notEquivalentFormula(value, v0);
					}
				}
				else {
					break _loop37;
				}
				
			} while (true);
			}
		}
		else {
			throw new NoViableAltException(LT(1), getFilename());
		}
		
		return value;
	}
	
	public final Expression  valueExp60() throws RecognitionException, TokenStreamException {
		 Expression value = null; ;
		
		Expression v = null;
		
		value=valueExp50();
		{
		_loop40:
		do {
			if ((LA(1)==LITERAL_OR)) {
				match(LITERAL_OR);
				v=valueExp60();
				if ( inputState.guessing==0 ) {
					value = Construct.orFormula(value, v);
				}
			}
			else {
				break _loop40;
			}
			
		} while (true);
		}
		return value;
	}
	
	public final Expression  valueExp50() throws RecognitionException, TokenStreamException {
		 Expression value = null; ;
		
		Expression v = null;
		
		value=valueExp45();
		{
		_loop43:
		do {
			if ((LA(1)==LITERAL_AND)) {
				match(LITERAL_AND);
				v=valueExp50();
				if ( inputState.guessing==0 ) {
					value = Construct.andFormula(value, v);
				}
			}
			else {
				break _loop43;
			}
			
		} while (true);
		}
		return value;
	}
	
	public final Expression  valueExp45() throws RecognitionException, TokenStreamException {
		 Expression value = null; ;
		
		Expression v = null;
		
		switch ( LA(1)) {
		case LITERAL_NOT:
		{
			match(LITERAL_NOT);
			v=valueExp45();
			if ( inputState.guessing==0 ) {
				value = Construct.notFormula(v);
			}
			break;
		}
		case IDENT:
		case 9:
		case 39:
		case 40:
		case NUMBER:
		case LITERAL_TRUE:
		case LITERAL_FALSE:
		case 50:
		case LITERAL_IF:
		{
			value=valueExp43();
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		return value;
	}
	
	public final Expression  valueExp43() throws RecognitionException, TokenStreamException {
		 Expression value = null; ;
		
		Expression v = null;
		
		value=valueExp40();
		{
		if ((LA(1)==7)) {
			match(7);
			v=valueExp43();
			if ( inputState.guessing==0 ) {
				value = Construct.equalsFormula(value, v);
			}
		}
		else if ((LA(1)==34)) {
			match(34);
			v=valueExp43();
			if ( inputState.guessing==0 ) {
				value = Construct.notEqualsFormula(value, v);
			}
		}
		else if ((_tokenSet_2.member(LA(1)))) {
		}
		else {
			throw new NoViableAltException(LT(1), getFilename());
		}
		
		}
		return value;
	}
	
	public final Expression  valueExp40() throws RecognitionException, TokenStreamException {
		 Expression value = null; ;
		
		Expression v = null;
		
		value=valueExp30();
		{
		if ((LA(1)==35)) {
			match(35);
			v=valueExp40();
			if ( inputState.guessing==0 ) {
				value = Construct.lessFormula(value, v);
			}
		}
		else if ((LA(1)==36)) {
			match(36);
			v=valueExp40();
			if ( inputState.guessing==0 ) {
				value = Construct.lessEqualFormula(value, v);
			}
		}
		else if ((LA(1)==37)) {
			match(37);
			v=valueExp40();
			if ( inputState.guessing==0 ) {
				value = Construct.greaterFormula(value, v);
			}
		}
		else if ((LA(1)==38)) {
			match(38);
			v=valueExp40();
			if ( inputState.guessing==0 ) {
				value = Construct.greaterEqualFormula(value, v);
			}
		}
		else if ((_tokenSet_2.member(LA(1)))) {
		}
		else {
			throw new NoViableAltException(LT(1), getFilename());
		}
		
		}
		return value;
	}
	
	public final Expression  valueExp30() throws RecognitionException, TokenStreamException {
		 Expression value = null; ;
		
		Expression v = null;
		
		value=valueExp10();
		{
		_loop51:
		do {
			if ((LA(1)==39)) {
				match(39);
				v=valueExp30();
				if ( inputState.guessing==0 ) {
					value = Construct.plusTerm(value, v);
				}
			}
			else if ((LA(1)==40)) {
				match(40);
				v=valueExp30();
				if ( inputState.guessing==0 ) {
					value = Construct.minusTerm(value, v);
				}
			}
			else {
				break _loop51;
			}
			
		} while (true);
		}
		return value;
	}
	
	public final Expression  valueExp10() throws RecognitionException, TokenStreamException {
		 Expression value = null; ;
		
		Expression v = null;
		
		value=valueExp9();
		{
		_loop54:
		do {
			if ((LA(1)==41)) {
				match(41);
				v=valueExp9();
				if ( inputState.guessing==0 ) {
					value = Construct.timesTerm(value, v);
				}
			}
			else if ((LA(1)==42)) {
				match(42);
				v=valueExp9();
				if ( inputState.guessing==0 ) {
					value = Construct.dividesTerm(value, v);
				}
			}
			else {
				break _loop54;
			}
			
		} while (true);
		}
		return value;
	}
	
	public final Expression  valueExp9() throws RecognitionException, TokenStreamException {
		 Expression value = null; ;
		
		Expression v = null;
		
		value=valueExp8();
		{
		_loop57:
		do {
			if ((LA(1)==43)) {
				match(43);
				v=valueExp8();
				if ( inputState.guessing==0 ) {
					value = Construct.powerTerm(value, v);
				}
			}
			else {
				break _loop57;
			}
			
		} while (true);
		}
		return value;
	}
	
	public final Expression  valueExp8() throws RecognitionException, TokenStreamException {
		 Expression value = null; ;
		
		Expression v1 = null;
		
		switch ( LA(1)) {
		case 39:
		{
			match(39);
			v1=valueExp6();
			if ( inputState.guessing==0 ) {
				value = v1;
			}
			break;
		}
		case 40:
		{
			match(40);
			v1=valueExp6();
			if ( inputState.guessing==0 ) {
				value = Construct.negationTerm(v1);
			}
			break;
		}
		case IDENT:
		case 9:
		case NUMBER:
		case LITERAL_TRUE:
		case LITERAL_FALSE:
		case 50:
		case LITERAL_IF:
		{
			value=valueExp6();
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		return value;
	}
	
	public final Expression  valueExp6() throws RecognitionException, TokenStreamException {
		 Expression value = null; ;
		
		Token  m = null;
		Token  i = null;
		Expression v0 = null; Expression v1 = null; Vector v = null;
		
		value=valueExp5();
		{
		_loop64:
		do {
			if ((LA(1)==LITERAL_WITH)) {
				match(LITERAL_WITH);
				if ( inputState.guessing==0 ) {
					v = new Vector();
				}
				{
				int _cnt63=0;
				_loop63:
				do {
					switch ( LA(1)) {
					case 45:
					{
						match(45);
						{
						switch ( LA(1)) {
						case NUMBER:
						{
							m = LT(1);
							match(NUMBER);
							if ( inputState.guessing==0 ) {
								v.add(Construct.selectorNumber(
									    Construct.number(m.getText())));
							}
							break;
						}
						case IDENT:
						{
							i = LT(1);
							match(IDENT);
							if ( inputState.guessing==0 ) {
								v.add(Construct.selectorIdentifier(
									    Construct.reference(i.getText())));
							}
							break;
						}
						default:
						{
							throw new NoViableAltException(LT(1), getFilename());
						}
						}
						}
						break;
					}
					case 15:
					{
						match(15);
						v0=valueExp();
						match(16);
						if ( inputState.guessing==0 ) {
							v.add(Construct.selectorIndex(v0));
						}
						break;
					}
					default:
					{
						if ( _cnt63>=1 ) { break _loop63; } else {throw new NoViableAltException(LT(1), getFilename());}
					}
					}
					_cnt63++;
				} while (true);
				}
				match(47);
				v1=valueExp();
				if ( inputState.guessing==0 ) {
					value = Construct.updateTerm(value, 
						ASTUtil.toSelectorArray(v), v1);
				}
			}
			else {
				break _loop64;
			}
			
		} while (true);
		}
		return value;
	}
	
	public final Expression  valueExp5() throws RecognitionException, TokenStreamException {
		 Expression value = null; ;
		
		Token  n = null;
		Token  j = null;
		Expression v0 = null; Expression v1 = null; Vector v = null;
		
		value=valueExp3();
		{
		_loop68:
		do {
			switch ( LA(1)) {
			case 45:
			{
				match(45);
				{
				switch ( LA(1)) {
				case NUMBER:
				{
					n = LT(1);
					match(NUMBER);
					if ( inputState.guessing==0 ) {
						value = Construct.selectionTerm(value, 
							      Construct.selectorNumber(Construct.number(n.getText())));
					}
					break;
				}
				case IDENT:
				{
					j = LT(1);
					match(IDENT);
					if ( inputState.guessing==0 ) {
						value = Construct.selectionTerm(value, 
							      Construct.selectorIdentifier(Construct.reference(j.getText())));
					}
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1), getFilename());
				}
				}
				}
				break;
			}
			case 15:
			{
				match(15);
				v0=valueExp();
				match(16);
				if ( inputState.guessing==0 ) {
					value = Construct.selectionTerm(value, 
						Construct.selectorIndex(v0));
				}
				break;
			}
			default:
			{
				break _loop68;
			}
			}
		} while (true);
		}
		return value;
	}
	
	public final Expression  valueExp3() throws RecognitionException, TokenStreamException {
		 Expression value = null; ;
		
		Vector v = null; Expression v0 = null;
		
		value=valueExp0();
		{
		_loop73:
		do {
			if ((LA(1)==9)) {
				match(9);
				v0=valueExp();
				if ( inputState.guessing==0 ) {
					v = new Vector(); v.add(v0);
				}
				{
				_loop72:
				do {
					if ((LA(1)==10)) {
						match(10);
						v0=valueExp();
						if ( inputState.guessing==0 ) {
							v.add(v0);
						}
					}
					else {
						break _loop72;
					}
					
				} while (true);
				}
				match(11);
				if ( inputState.guessing==0 ) {
					value = 
						Construct.applicationExpression(value, ASTUtil.toExpressionArray(v));
				}
			}
			else {
				break _loop73;
			}
			
		} while (true);
		}
		return value;
	}
	
	public final Expression  valueExp0() throws RecognitionException, TokenStreamException {
		 Expression value = null; ;
		
		Token  i = null;
		Token  n = null;
		Token  i1 = null;
		Token  i2 = null;
		Expression v1 = null; Expression v2 = null; Expression v3 = null;
		Stack s = null; Vector v = null;
		
		switch ( LA(1)) {
		case IDENT:
		{
			i = LT(1);
			match(IDENT);
			if ( inputState.guessing==0 ) {
				Reference ident = Construct.reference(i.getText());
					CVCLFormulaMask mask = State.getFormulaMask();
					if (mask != null) value = mask.getFormula(ident);
					if (value == null) value = ident; 
				
			}
			break;
		}
		case NUMBER:
		{
			n = LT(1);
			match(NUMBER);
			if ( inputState.guessing==0 ) {
				value = Construct.number(n.getText());
			}
			break;
		}
		case LITERAL_TRUE:
		{
			match(LITERAL_TRUE);
			if ( inputState.guessing==0 ) {
				value = Construct.logical(true);
			}
			break;
		}
		case LITERAL_FALSE:
		{
			match(LITERAL_FALSE);
			if ( inputState.guessing==0 ) {
				value = Construct.logical(false);
			}
			break;
		}
		case 9:
		{
			match(9);
			v1=valueExp();
			if ( inputState.guessing==0 ) {
				v = new Vector(); v.add(v1);
			}
			{
			_loop76:
			do {
				if ((LA(1)==10)) {
					match(10);
					v2=valueExp();
					if ( inputState.guessing==0 ) {
						v.add(v2);
					}
				}
				else {
					break _loop76;
				}
				
			} while (true);
			}
			match(11);
			if ( inputState.guessing==0 ) {
				if (v.size()==1) 
					  value = (Expression)(v.elementAt(0));
					else 
					  value = Construct.tupleTerm(ASTUtil.toExpressionArray(v));
			}
			break;
		}
		case 50:
		{
			match(50);
			if ( inputState.guessing==0 ) {
				v = new Vector();
			}
			i1 = LT(1);
			match(IDENT);
			match(47);
			v1=valueExp();
			if ( inputState.guessing==0 ) {
				v.add(Construct.valuedIdentifier(
						   Construct.reference(i1.getText()), v1));
			}
			{
			_loop78:
			do {
				if ((LA(1)==10)) {
					match(10);
					i2 = LT(1);
					match(IDENT);
					match(47);
					v2=valueExp();
					if ( inputState.guessing==0 ) {
						v.add(Construct.valuedIdentifier(
							       Construct.reference(i2.getText()), v2));
					}
				}
				else {
					break _loop78;
				}
				
			} while (true);
			}
			match(51);
			if ( inputState.guessing==0 ) {
				value = Construct.recordTerm(ASTUtil.toValuedIdentifierArray(v));
			}
			break;
		}
		case LITERAL_IF:
		{
			match(LITERAL_IF);
			v1=valueExp();
			match(LITERAL_THEN);
			v2=valueExp();
			if ( inputState.guessing==0 ) {
				s = new Stack(); s.push(v1); s.push(v2);
			}
			{
			_loop80:
			do {
				if ((LA(1)==LITERAL_ELSIF)) {
					match(LITERAL_ELSIF);
					v1=valueExp();
					match(LITERAL_THEN);
					v2=valueExp();
					if ( inputState.guessing==0 ) {
						s.push(v1); s.push(v2);
					}
				}
				else {
					break _loop80;
				}
				
			} while (true);
			}
			match(LITERAL_ELSE);
			v3=valueExp();
			match(LITERAL_ENDIF);
			if ( inputState.guessing==0 ) {
				value = v3;
				do { v2 = (Expression)(s.pop()); v1 = (Expression)(s.pop()); 
					   value = Construct.ifThenElseExpression(v1, v2, value); 
				} while (!s.isEmpty());
				
			}
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		return value;
	}
	
	public final void param(
		Vector sequence
	) throws RecognitionException, TokenStreamException {
		
		Token  i1 = null;
		Token  i2 = null;
		Vector v = new Vector(); Type t=null;
		
		i1 = LT(1);
		match(IDENT);
		if ( inputState.guessing==0 ) {
			v.add(Construct.valueDeclIdentifier(i1.getText()));
		}
		{
		_loop86:
		do {
			if ((LA(1)==10)) {
				match(10);
				i2 = LT(1);
				match(IDENT);
				if ( inputState.guessing==0 ) {
					v.add(Construct.valueDeclIdentifier(i2.getText()));
				}
			}
			else {
				break _loop86;
			}
			
		} while (true);
		}
		match(5);
		t=typeExp();
		if ( inputState.guessing==0 ) {
			Iterator i = v.iterator();
				while (i.hasNext()) 
				{ sequence.add(Construct.typedIdentifier(
					(ValueDeclIdentifier)(i.next()), t)); }
			
		}
	}
	
	
	public static final String[] _tokenNames = {
		"<0>",
		"EOF",
		"<2>",
		"NULL_TREE_LOOKAHEAD",
		"IDENT",
		"\":\"",
		"\"TYPE\"",
		"\"=\"",
		"\"->\"",
		"\"(\"",
		"\",\"",
		"\")\"",
		"\"BOOLEAN\"",
		"\"INT\"",
		"\"REAL\"",
		"\"[\"",
		"\"]\"",
		"\"[#\"",
		"\"#]\"",
		"\"ARRAY\"",
		"\"OF\"",
		"\"SUBTYPE\"",
		"\"..\"",
		"\"LET\"",
		"\"IN\"",
		"\"LAMBDA\"",
		"\"FORALL\"",
		"\"EXISTS\"",
		"\"=>\"",
		"\"<=>\"",
		"\"XOR\"",
		"\"OR\"",
		"\"AND\"",
		"\"NOT\"",
		"\"/=\"",
		"\"<\"",
		"\"<=\"",
		"\">\"",
		"\">=\"",
		"\"+\"",
		"\"-\"",
		"\"*\"",
		"\"/\"",
		"\"^\"",
		"\"WITH\"",
		"\".\"",
		"NUMBER",
		"\":=\"",
		"\"TRUE\"",
		"\"FALSE\"",
		"\"(#\"",
		"\"#)\"",
		"\"IF\"",
		"\"THEN\"",
		"\"ELSIF\"",
		"\"ELSE\"",
		"\"ENDIF\"",
		"IGNORE",
		"LPAR",
		"RPAR",
		"LBRACK",
		"RBRACK",
		"LPARGRID",
		"RPARGRID",
		"LBRACKGRID",
		"RBRACKGRID",
		"PERIOD",
		"COLON",
		"SEMICOLON",
		"COMMA",
		"ASSIGNMENT",
		"EQUALITY",
		"NONEQUALITY",
		"LESS",
		"LESSEQ",
		"GREATER",
		"GREATEREQ",
		"PLUS",
		"MINUS",
		"TIMES",
		"DIVIDES",
		"POWER",
		"IMPLIES",
		"EQUIV",
		"ARROW",
		"DOTDOT",
		"LETTER",
		"DIGIT",
		"WS",
		"EOL",
		"COMMENT"
	};
	
	private static final long[] mk_tokenSet_0() {
		long[] data = { 11203088L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_0 = new BitSet(mk_tokenSet_0());
	private static final long[] mk_tokenSet_1() {
		long[] data = { 6545951065899536L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_1 = new BitSet(mk_tokenSet_1());
	private static final long[] mk_tokenSet_2() {
		long[] data = { 137394964169559170L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_2 = new BitSet(mk_tokenSet_2());
	
	}
