// ----------------------------------------------------------------------------
// NotFormula.java
// Handling of negations
// $Id: NotFormula.java,v 1.10 2006/02/22 20:38:08 schreine Exp $
//
// Author: Wolfgang Schreiner <Wolfgang.Schreiner@risc.uni-linz.ac.at>
// Copyright (C) 2005, Research Institute for Symbolic Computation (RISC)
// Johannes Kepler University, Linz, Austria, http://www.risc.uni-linz.ac.at
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
// ----------------------------------------------------------------------------
package fmrisc.Syntax;

/**
 * Handling of negations
 */
public final class NotFormula extends UnaryExpression
{
  /****************************************************************************
   * construct negation (not formula) of base formula
   * @param base the base formula
   ***************************************************************************/
  public NotFormula(Expression base)
  {
    super("NOT ", base);
  }
  
  /***************************************************************************
   * get binding level for printing (lower numbers mean greater binding power)
   * @return the priority level
   **************************************************************************/
  public int getPriority()
  {
    return 45;
  }
  
  /***************************************************************************
   * Construct binary expression of the same kind as this expression.
   * @param base an expression.
   * @return a unary expression of the same kind as this expression
   *         with subexpression base.
   **************************************************************************/
  protected UnaryExpression construct(Expression base)
  {
    return Construct.notFormula(base);
  }
  
}
